--[[ MMT Console Commands]]--

--[[ TO-DO:
	
	- Make a command that allows the user to change the menu key.


]]--

local function SurprisePizza(player, arg1, arg2, arg3, arg4, arg5, arg6)
	local cmdname = "orderpizza"
	local sbln, tbln, abln = false, false, false
	local size, toppings, address
	if arg1 == "-size"
		sbln = true
		size = arg2
	end
	if arg3 == "-size"
		sbln = true
		size = arg4
	end
	if arg5 == "-size"
		sbln = true
		size = arg6
	end
		if arg1 == "-toppings"
		tbln = true
		toppings = arg2
	end
	if arg3 == "-toppings"
		tbln = true
		toppings = arg4
	end
	if arg5 == "-toppings"
		tbln = true
		toppings = arg6
	end
		if arg1 == "-address"
		abln = true
		address = arg2
	end
	if arg3 == "-address"
		abln = true
		address = arg4
	end
	if arg5 == "-address"
		abln = true
		address = arg6
	end
	if not (sbln and abln and tbln)
		CONS_Printf(player, MMT_cmdDesc(MMT_commandDescription, cmdname))
		return
	end
	print(player.name .. " has ordered a " .. size .. " sized ordinary pizza, with " .. toppings .. " toppings to " .. address)
	chatprint(player.name .. " has ordered a " .. size .. " sized ordinary pizza, with " .. toppings .. " toppings to " .. address)
	if player.mo
		local thepizzais = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.ceilingz-(6*FRACUNIT), MT_AGGRESSIVE)
		thepizzais.target = player.mo
		size = string.lower($)
		toppings = string.lower($)
		if size == "large" or size == "medium" or size == "small" or size == "personal" or size == "xl" or size == "extra large"  or size == "extralarge"
			thepizzais.sizeoption = size
		end
		if toppings == "deton"
			thepizzais.state = S_THEPIZZAISEXPLOSIVE
		end
		S_StartSound(player.mo, sfx_pizsum)
	end
end

local function MMTMenuKey(player, arg1)
local cmdname = "mmtmenukey"
	if MMT_KeyToNum(arg1) or arg1 == "off"
		player.MMT.MMTmenukey = arg1
		if player.MMT.MMTautosave != "off"
			MMT_SaveSpecificSetting(player, "MMTautosave") 
		end
		player.MMT.MMTOptionChanged = true
		MMT_changedvar(player, cmdname, arg1)
	else
		CONS_Printf(player, MMT_cmdDesc(MMT_commandDescription, cmdname))
		MMT_changedvar(player, cmdname, player.MMT.MMTmenukey) 
		CONS_Printf(player, "*\x8E Options:\x80 off, weaponnext, weaponprev, attack/ringtoss, use/spin, camleft, camright, tossflag, firenormal/ringtossnormal, custom1, custom2, custom3")
	end
end

local function MMTChangeVar(player, arg1, arg2)
local cmdname = "mmtchangevar"
	local RegularTextColor = MMTregulartext
	local SetOptionTextColor = MMTsetoptionc	
		
	if player.MMT != nil
		RegularTextColor = player.MMT.MMTregulartext
		SetOptionTextColor = player.MMT.MMTsetoptionc
	end
	
	if arg1 and MMT_tablesearch(MMTVarList, arg1)
		arg1 = MMT_tablesearch(MMTVarList, arg1)
	end
	
	if arg1
		if not MMT_invtablesearch(MMTVarList, arg1)
			arg1 = string.lower($)
			arg1 = $:gsub("mmt", "MMT")
			arg1 = $:gsub("hud", "HUD")
			arg1 = $:gsub("sfx", "SFX")
			arg1 = string.gsub(" "..$, "%W%l", string.upper):sub(2)
			mmtdebuggerPrint("changed arg1 to: " + arg1)
		end
	else
		CONS_Printf(player, MMT_cmdDesc(MMT_commandDescription, cmdname))
		return
	end
	
	if arg2
		arg2 = string.lower($)
	else
		if MMT_invtablesearch(MMTVarList, arg1)
			CONS_Printf(player, "\x88" .. arg1)
			CONS_Printf(player, "\x86" .. MMT_invtablesearch(MMTVarListDescription, arg1))
			if MMT_invtablesearch(MMTVarListDescription2, arg1) CONS_Printf(player, "\x86" .. MMT_invtablesearch(MMTVarListDescription2, arg1)) end
			--CONS_Printf(player, "\x81 Options:")
			local LookUp = MMT_invtablesearch(MMTVarListOptionType, arg1)
			local LookUpTable = _G[LookUp]
			for key, value in pairs(LookUpTable) do
				local SpiceText = ""
				local Arrow = " "
				local XtraText = ""
				if MMTVarListLocalVar[arg1] -- local variable
					if key == _G[MMT_invtablesearch(MMTVarList, arg1)]
						SpiceText = MMT_ColorToLuaC(SetOptionTextColor)
						Arrow = MMT_ColorToLuaC(SetOptionTextColor) .. ">"
					elseif MMT_invtablesearch(MMTVarListTable, arg1) and _G[MMT_invtablesearch(MMTVarListTable, arg1)][key] -- player is changing a table, and the option is turned on in table 
						SpiceText = "\x8E"
					else
						SpiceText = MMT_ColorToLuaC(RegularTextColor)
					end
				else -- player variable
					if player.MMT
						if key == player.MMT[MMT_invtablesearch(MMTVarList, arg1)]
							SpiceText = MMT_ColorToLuaC(SetOptionTextColor)
							Arrow = MMT_ColorToLuaC(SetOptionTextColor) .. ">"
						elseif MMT_invtablesearch(MMTVarListDifPlayerTable, arg1) -- mod option menu 
							if MMT_invtablesearch(MMTVarListDifPlayerTable, arg1) == ""
								if key == player[MMT_invtablesearch(MMTVarList, arg1)]
									SpiceText = MMT_ColorToLuaC(SetOptionTextColor)
									Arrow = MMT_ColorToLuaC(SetOptionTextColor) .. ">"
								else
									SpiceText = MMT_ColorToLuaC(RegularTextColor) -- required, lest everything get upset 
								end
							else
								if key == player[MMT_invtablesearch(MMTVarListDifPlayerTable, arg1)][MMT_invtablesearch(MMTVarList, arg1)]
									SpiceText = MMT_ColorToLuaC(SetOptionTextColor)
									Arrow = MMT_ColorToLuaC(SetOptionTextColor) .. ">"
								else
									SpiceText = MMT_ColorToLuaC(RegularTextColor)
								end
							end
						else
							SpiceText = MMT_ColorToLuaC(RegularTextColor)
						end
					else
						SpiceText = MMT_ColorToLuaC(RegularTextColor)
					end
				end
				if arg1 == "Misc. Options" and MMTVarList[key] != "DnD"
					if MMT_invtablesearch(MMTVarListLocalVar, key)
						XtraText = ": " + _G[MMTVarList[key]]
					else
						XtraText = ": " + player.MMT[MMTVarList[key]]
					end
				end
				CONS_Printf(player, Arrow .. "\x87* " .. SpiceText .. key + XtraText)
			end
		return
		end
	end
	
	if MMT_invtablesearch(MMTVarList, arg1)
		mmtdebuggerPrint("yes")
		local Validity = MMT_invtablesearch(MMTVarListOptionType, arg1)
		local ValidityTable = _G[Validity]
		local ShouldIGo
		for key, value in pairs(ValidityTable) do
			if key == arg2
				ShouldIGo = true
			end
		end
		if ShouldIGo
			mmtdebuggerPrint("YES!!")
			for key, value in pairs(MMTVarList) do
				if key == arg1
					if arg1 == "Nag Prompt" --MMT_invtablesearch(MMTVarListNumber, key) >= (MMTmaxoptions+1) -- player attempted illegal action >:( 
						CONS_Printf(player, "\x85\ERROR:\x80 You shouldn't change this setting!")
						return
					end
					if MMTVarListLocalVar[arg1] -- local variable
						if (netgame and not MMT_IsPlayerAdmin(player))
							CONS_Printf(player, "\x85\ERROR:\x80 Can not change as a non-admin!")
							return 
						elseif (netgame and MMT_invtablesearch(MMTVarListSPOnly, arg1)) 
							CONS_Printf(player, "\x85\ERROR:\x80 Can not change while in multiplayer!")
							return
						elseif (not netgame and MMT_invtablesearch(MMTVarListMPOnly, arg1)) 
							CONS_Printf(player, "\x85\ERROR:\x80 Can not change while in single player!")
							return 
						end
						if MMT_invtablesearch(MMTVarListTable, arg1) -- table-based variable
							local tablevar = MMT_invtablesearch(MMTVarListTable, arg1)
							mmtdebuggerPrint("table: " + tablevar)
							if MMT_invtablesearch(_G[tablevar], arg2) -- already exists, remove it from table 
								MMT_tableremoveKey(_G[tablevar], arg2)
								CONS_Printf(player, "*\x8A " .. arg1 .. "\x80 has disabled: \x87" +arg2)
							else -- does not exist, insert variable
								_G[tablevar][arg2] = "" -- too lazy to see if table.insert would do the trick better, don't try this at home
								CONS_Printf(player, "*\x8A " .. arg1 .. "\x80 has enabled: \x87" +arg2)
							end
							MMTbanskinNum = MMT_tablelength(MMTbanskin) + 1
						else
							if tonumber(value) value = tonumber($) end
							_G[value] = arg2
						end
					else -- player variable
						if player.MMT == nil
							CONS_Printf(player, "\x85\ERROR:\x80 Can not change player variable while not in play!")
							return
						end
						if tonumber(value) value = tonumber($) end
						if MMTVarListDifPlayerTable[arg1]
							if MMTVarListDifPlayerTable[arg1] == ""
								player[MMT_invtablesearch(MMTVarList, arg1)] = arg2
								mmtdebuggerPrint("player." .. MMT_invtablesearch(MMTVarList, arg1) .. " = " ..  arg2)
							else
								player[MMTVarListDifPlayerTable[arg1]][MMT_invtablesearch(MMTVarList, arg1)] = arg2
								mmtdebuggerPrint("player." .. MMTVarListDifPlayerTable[arg1] .. "." .. MMT_invtablesearch(MMTVarList, arg1) .. " = " ..  arg2)
							end
							player.MMT.MMTModOptionChanged = MMT_invtablesearch(MMTVarListModSettingName, arg1)
						else
							player.MMT[value] = arg2
						end
					end
					
					if not MMT_invtablesearch(MMTVarListTable, arg1) 
						MMT_changedvar(player, arg1, arg2) 
					end
					
					if player.MMT != nil
						if player.MMT.MMTautosave != "off"
							MMT_SaveSpecificSetting(player, value) 
						end
						player.MMT.MMTOptionChanged = true
					else
						CONS_Printf(player, "\x88\NOTICE:\x80 Can not auto-save variable while not in play!")
					end
				end
			end
		else
			mmtdebuggerPrint("invalid arg2")
		end
	elseif arg1 == "List" and (tonumber(arg2) or arg2 == nil) -- list out all available options, per page (MMTitemsperpage; if doesn't exist, use default)
		if arg2 == nil arg2 = 1 end
		arg2 = tonumber(arg2) - 1
		local ItemsPerPage = MMTitemsperpage
		if player.MMT != nil
			ItemsPerPage = player.MMT.MMTitemsperpage
		end
		for key, value in pairs(MMTVarList) do
			if MMTVarListNumber[key] >= (1+(arg2*ItemsPerPage)) and MMTVarListNumber[key] <= (ItemsPerPage+(arg2*ItemsPerPage)) -- current page number multiplier 
				local SpiceText
				if ((netgame and not MMT_IsPlayerAdmin(player)) and MMTVarListLocalVar[key]) or (netgame and MMTVarListSPOnly[key]) or (not netgame and MMTVarListMPOnly[key]) or (not MMTVarListLocalVar[key] and player.MMT == nil) -- gray out the variable
					SpiceText = "\x86"
				else
					SpiceText = ""
				end
				local SettingToDisplay
				if value != "DnD"
					if MMT_invtablesearch(MMTVarListLocalVar, key)
						SettingToDisplay = ": " + MMT_ColorToLuaC(SetOptionTextColor) + _G[value]
					else
						if player.MMT != nil 
							SettingToDisplay = ": " + MMT_ColorToLuaC(SetOptionTextColor) + player.MMT[value] 
						else -- player is either on title screen or in console, display default 
							SettingToDisplay = ": " + MMT_ColorToLuaC(SetOptionTextColor) + _G[value]
						end
					end
				else
					SettingToDisplay = ""
				end
				if MMT_invtablesearch(MMTVarListNumber, key) < (MMTmaxoptions+1) -- max options reached, don't display anything beyond here 
					CONS_Printf(player, "\x87*  " + MMT_ColorToLuaC(RegularTextColor) + SpiceText + key + SettingToDisplay)
				end
			end
		end
	else
		CONS_Printf(player, MMT_cmdDesc(MMT_commandDescription, cmdname))
	end
end


COM_AddCommand("orderpizza", SurprisePizza, 0)
COM_AddCommand("mmtmenukey", MMTMenuKey, 0)
COM_AddCommand("mmtchangevar", MMTChangeVar, 0)


addHook("NetVars", function(net)
	MMTeverysuper = net(MMTeverysuper)
	MMTpreserveshield = net(MMTpreserveshield)
	MMTdebuggerprinting = net(MMTdebuggerprinting)
	MMTtokentorings = net(MMTtokentorings)
	MMTclassicshields = net(MMTclassicshields)
	MMTscorecontinues = net(MMTscorecontinues)
	MMTclassicspecialstage = net(MMTclassicspecialstage)
	
	VLOT_BanSkin = net(VLOT_BanSkin)
	MMTbanskinNum = net(MMTbanskinNum)
	MMTbanskin = net(MMTbanskin)
end)